PL/php - Bug #4974

Memory leak in SPI functions
11/26/2005 06:49 AM - Alvaro Herrera

Status: Closed Start date:

Priority: High Due date:

Assignee: Alvaro Herrera % Done: 0%
Category: Estimated time: 0.00 hour
Target version: Release 1.1

Resolution: fixed

Description

This can be reproduced with the following function:

create or replace function test_spi_1(int) returns int language plphp as $$

Squery = "select generate_series(l, S$argsr0)";
Sresult = spi_exec (Squery);

Smsg = "processed: " . spi_processed($result) . " ";
Smsg .= "status: " . spi_status(S$Sresult);

pg_raise('notice', $msqg);

Sa = 0;

while (Srow = spi_fetch_row (Sresult))
$a += $row['generate_series'];

pg_raise ('notice', "total sum is " . $a);

return $a;

$$;

Setting a memory limit of 3M on my i686-linux machine crashes with this call:
select test_spi_1(142857);

NOTICE: plphp: processed: 142857 status: SPI_OK_SELECT

ERROR: plphp: Allowed memory size of 3145728 bytes exhausted (tried to allocate 12 bytes)

On a Turion64 machine it consumes much more memory, as the same example makes it crash with an 8M memory limit (which
doesn't make the i686 machine crash.)

History

#1 - 11/28/2005 11:35 AM - Alvaro Herrera

- Status changed from New to In Progress

Can't be reproduced any longer with the example provided, because the fix for #11 in r21 means that, for all practical purposes, there's no longer a
memory limit for the PHP engine. The memory leak is still with us, however.

#2 - 12/05/2005 07:34 AM - Alvaro Herrera
- Status changed from In Progress to Closed

- Resolution set to fixed
Fixed in r20.

#3 - 05/29/2006 02:49 AM - bford -
Keep a good job up! http:/quick-adult-links.com

#4 - 06/02/2006 01:48 PM - bford -
com/bed/sleep-comfort-adjustable-bed.html">sleep comfort adjustable bed</a>

//www.free-space.at/perfume/discontinued-coty-perfume.html">discontinued coty perfume</a>

com/bed/toddler-bed-bedding.html">toddler bed bedding</a>
com/bed/mosquito-net-bed-canopy.html">mosquito net bed canopy</a>
com/bed/metal-frame-sofa-bed.html">metal frame sofa bed</a>
com/bed/bunk-bed-tents.html">bunk bed tents</a>
com/bed/cosco-toddler-bed.html">cosco toddler bed</a>

//www.free-space.at/perfume/j-lo-perfume.html">j lo perfume</a>

com/bed/japanese-bed-sheets.html">japanese bed sheets</a>
com/bed/adjustable-bed-sheets.html">adjustable bed sheets</a>
com/bed/girl-bunk-bed.html">girl bunk bed</a>
com/bed/rustic-bunk-bed.html">rustic bunk bed</a>
com/bed/tanning-bed-lamp.html">tanning bed lamp</a>
